' FFSubmenu=Effekte
' FFName=Bannermaster
' FFScriptFiles=bannermaster.vbs
' fgt zwei oder mehrere Bilder zu einem Banner zusammen, indem weiche bergnge erzeugt werden (FF_MakeBanner)
' ** KGsoft (Andreas Kleingnther) 
' Version 1.2 vom 03.11.2011
' Version 1.4 vom 07.11.2011
' Version 1.5 vom 28.12.2013	Anpassung fr FF V 3.50 beta 37 
' Version 1.6 vom 27.04.2016	kleine Korrektur der Oberflche 

Option Explicit
Const Version = "V 1.6"
Const RegSchluessel = "bannermaster"		' Registryschlssel
Dim ListeBilder, ListeBilderFeld
Dim Bildbreite
Dim i
Dim Maxbreite
Dim Bildanzahlangabe
Dim g_XUnits, g_YUnits
Dim firstpoint
Dim aktbildpath
Dim revfeld, z

' fr Hilfe
Dim Taste2
Dim objFs, Kurzbeschreibung, KBvorhanden, LaengeMax
Dim WshShell
const SkriptName = "bannermaster.vbs"			' Skriptname

' Startwerte
Call Dialogaufbau
' Registry auslesen bzw. Startbelegung
Select Case FF_GetProfile(RegSchluessel, "Quelle")
	Case "ca_mark"
		FF_SetControl "Bannermaster","ca_mark_bool", "1"
		ListeBilder = FF_GetSelection(1)
	Case "li_mark"
		FF_SetControl "Bannermaster","li_mark_bool", "1"
		ListeBilder = FF_GetSelection(3)
	Case "li_all"
		FF_SetControl "Bannermaster","li_all_bool", "1"
		ListeBilder = FF_GetSelection(2)
	Case Else								' keine Quelle in der Registry notiert
		FF_SetControl "Bannermaster","ca_mark_bool", "1"
		ListeBilder = FF_GetSelection(1)
End Select

firstpoint = 0

Call Bilder_ermitteln
Call DialogAuswertung

Sub DialogAuswertung
	' Versionskontrolle
	If not Version_equal_or_better("3.30.17") Then 			' Tooltips erst ab 3.30 beta 6
		MsgBox "Das Skript funktioniert leider erst ab Version 3.30 build 17.", 64, "Bannermaster"
		Exit Sub
	End If
	
	FF_SetDialogTimer "Bannermaster", 500
	do								' Auswertung Button im Dialog
		Select Case FF_ShowDialog("Bannermaster")
			case "TIMER"
				FF_SetControl "Bannermaster", "|||", CInt(FF_GetControl ("Bannermaster", "berlappung") *Maxbreite / 255)
				FF_SetControl "Bannermaster", "||", Bildanzahlangabe
				if firstpoint = 0 Then			' nur 1x beim Start
					Call Bannerberechnung
					firstpoint = 1
				End If
			Case "ca_mark_bool"
				FF_SetControl "Bannermaster","ca_mark_bool", "1"
				FF_SetControl "Bannermaster","li_mark_bool", "0"
				FF_SetControl "Bannermaster","li_all_bool", "0"
				Call Bilder_ermitteln
				FF_SetControl "Bannermaster","||", Bildanzahlangabe
				FF_SetControl "Bannermaster","berlappung", 0
				FF_SetControl "Bannermaster", "|||", CInt(FF_GetControl ("Bannermaster", "berlappung") *Maxbreite / 255)
				Call Bannerberechnung
			Case "li_mark_bool"
				FF_SetControl "Bannermaster","ca_mark_bool", "0"
				FF_SetControl "Bannermaster","li_mark_bool", "1"
				FF_SetControl "Bannermaster","li_all_bool", "0"
				Call Bilder_ermitteln
				FF_SetControl "Bannermaster","||", Bildanzahlangabe
				FF_SetControl "Bannermaster","berlappung", 0
				FF_SetControl "Bannermaster", "|||", CInt(FF_GetControl ("Bannermaster", "berlappung") *Maxbreite / 255)
				Call Bannerberechnung
			Case "li_all_bool"
				FF_SetControl "Bannermaster","ca_mark_bool", "0"
				FF_SetControl "Bannermaster","li_mark_bool", "0"
				FF_SetControl "Bannermaster","li_all_bool", "1"
				Call Bilder_ermitteln
				FF_SetControl "Bannermaster","||", Bildanzahlangabe
				FF_SetControl "Bannermaster","berlappung", 0
				FF_SetControl "Bannermaster", "|||", CInt(FF_GetControl ("Bannermaster", "berlappung") *Maxbreite / 255)
				Call Bannerberechnung
			Case "revers_bool"
				ListeBilder = ""
				z = UBound(ListeBilderFeld)
				Redim revfeld (z)
				For i = 0 to z
					revfeld(z-i) = ListeBilderFeld(i) 
				Next
				For i = 0 to z
					ListeBilderFeld(i) = revfeld(i)
					ListeBilder = ListeBilder & ListeBilderFeld(i) & vbNewLine
				Next
				Call Bannerberechnung
			Case "Berechnen"
				Call Bannerberechnung
			Case "bernehmen"
				aktbildpath = FF_GetImagePath()			' aktuellen Bilderpfad speichern...
				FF_ImportImage aktbildpath & "\banner"	' - Pfad auch hier setze, damit Speichern unter stimmt -
				FF_SetImagePath aktbildpath				' ...und Pfad zurcksetzen weil FF_ImportImage auch den Pfad verndert
				FF_SetDirty True
				Call RegSchreiben
				Exit Sub
			Case "?"
				Call Help
			Case "Abbruch", "CANCEL"
				Call RegSchreiben
				Exit Sub
		End Select
	Loop
End Sub

Sub Bilder_ermitteln
	If FF_GetControl("Bannermaster","ca_mark_bool") = "1" Then ListeBilder = FF_GetSelection(1)
	If FF_GetControl("Bannermaster","li_mark_bool") = "1" Then ListeBilder = FF_GetSelection(3)
	If FF_GetControl("Bannermaster","li_all_bool") = "1" Then ListeBilder = FF_GetSelection(2)
	
	ListeBilderFeld = Split (ListeBilder, vbNewLine)
	Maxbreite = 30000
	For i = 0 to UBound (ListeBilderFeld)
		Bildbreite = FF_GetImageFileWidth(ListeBilderFeld(i))
	If Bildbreite < Maxbreite then Maxbreite = Bildbreite
	Next
	Maxbreite = Maxbreite - 1			' maximale berlappung ist Breite des schmalsten Bildes abzglich 1 pix
	Bildanzahlangabe = ubound(ListeBilderFeld) + 1 & " Bilder"
End Sub

Sub Bannerberechnung
	If ubound(ListeBilderFeld) > 0 Then	' min. 2 Bilder ausgewhlt
		If Version_equal_or_better("3.50.37") Then 			' genderte Syntax bei FF_MakeBanner ab FF 3.50.37
			FF_MakeBanner ListeBilder, FF_GetControl("Bannermaster", "|||"), 0
		Else												' Syntax fr Vorversionen
			FF_MakeBanner ListeBilder, FF_GetControl("Bannermaster", "|||")
		End If
		FF_SetControl "Bannermaster", "bild_img", 0
		FF_SetControl "Bannermaster", "|",FF_GetImageWidth() & " x " & FF_GetImageHeight() 
	Else
		MsgBox "Mindestens 2 Bilder mssen ausgewhlt werden.", 64, "Bannermaster"
	End If
End Sub

Sub RegSchreiben
	If FF_GetControl("Bannermaster","ca_mark_bool") = "1" Then FF_WriteProfile RegSchluessel, "Quelle", "ca_mark"
	If FF_GetControl("Bannermaster","li_mark_bool") = "1" Then FF_WriteProfile RegSchluessel, "Quelle", "li_mark"
	If FF_GetControl("Bannermaster","li_all_bool") = "1" Then FF_WriteProfile RegSchluessel, "Quelle", "li_all"
End Sub

Sub Dialogaufbau
	Dim zeile1, zeile2, zeile3
	Call Get_Dialogunits(g_XUnits,g_YUnits)
	' Randkorrektur
	g_XUnits = g_XUnits - 20
	g_YUnits = g_YUnits - 45
	
	FF_AddDialog "Bannermaster", g_XUnits, g_YUnits
	FF_AddControl "Bannermaster","bild_img","IMAGE",0 ,0 ,g_XUnits, g_YUnits - 60

	' links ausgerichtet
	FF_AddControl "Bannermaster","Bilderquelle","GROUP",3,g_YUnits - 60+17,101,40
	FF_AddControl "Bannermaster","ca_mark_bool","BOOL",7,g_YUnits - 60+26,8,8
	FF_AddControl "Bannermaster","li_mark_bool","BOOL",7,g_YUnits - 60+36,8,8
	FF_AddControl "Bannermaster","li_all_bool","BOOL",7,g_YUnits - 60+46,8,8
	FF_SetControlStyle "Bannermaster","ca_mark_bool",16384
	FF_SetControlStyle "Bannermaster","li_mark_bool",16384
	FF_SetControlStyle "Bannermaster","li_all_bool",16384
	FF_AddControl "Bannermaster","Computeransicht, markierte Bilder","STATIC",18,g_YUnits - 60+24,85,11
	FF_AddControl "Bannermaster","Bilderliste, markierte Bilder","STATIC",18,g_YUnits - 60+34,81,11
	FF_AddControl "Bannermaster","Bilderliste, alle Bilder","STATIC",18,g_YUnits - 60+44,76,11
	FF_AddControl "Bannermaster","berlappung","HSLIDER",3,g_YUnits - 60+0,250,12
	FF_AddControl "Bannermaster","Berechnen","BUTTON",210,g_YUnits - 60+25,48,16
	FF_AddControl "Bannermaster","revers_bool","BOOL", 210,g_YUnits - 60+46,8,8
	FF_SetControlStyle "Bannermaster","revers_bool",16384
	FF_AddControl "Bannermaster","Reihenfolge umkehren","STATIC", 220, g_YUnits - 60+44, 55, 11
	
	FF_AddControl "Bannermaster","|||","STATIC",159,g_YUnits - 60+34,30,11
	FF_AddControl "Bannermaster","berlappung in px:","STATIC",110,g_YUnits - 60+34,47,11
	FF_AddControl "Bannermaster","Bilderanzahl:","STATIC",110,g_YUnits - 60+24,35,11
	FF_AddControl "Bannermaster","||","STATIC",159,g_YUnits - 60+24,30,11
	FF_AddControl "Bannermaster","|","STATIC",159,g_YUnits - 60+44,40,11
	FF_AddControl "Bannermaster","Ergebnisbild:","STATIC",110,g_YUnits - 60+44,33,11
	
	
	' rechts ausgerichtet
	FF_AddControl "Bannermaster","bernehmen","BUTTON",g_XUnits-160+104,g_YUnits - 60+35,48,16
	FF_AddControl "Bannermaster","Abbruch","BUTTON",g_XUnits-160+46,g_YUnits - 60+35,48,16
	FF_AddControl "Bannermaster","?","BUTTON",g_XUnits-160+0,g_YUnits - 60+35,18,16
	FF_AddControl "Bannermaster",Version,"STATIC",g_XUnits-160+25,g_YUnits - 60+37,19,11

End Sub

Sub Get_Dialogunits(byRef p_XUnits,byRef p_YUnits)
    ' ermittelt die Dialogeinheiten des aktuellen Bildschirms
    ' bergibt in den bergabeparametern die Werte fr die Horizontale und Vertikale
    const SM_CXSCREEN=0
    const SM_CYSCREEN=1
    p_XUnits=FF_GetSystemMetrics(SM_CXSCREEN)*4\(CDbl(FF_GetDialogBaseUnits) Mod &h10000&)
    p_YUnits=FF_GetSystemMetrics(SM_CYSCREEN)*8\(CDbl(FF_GetDialogBaseUnits)  \  &h10000&)
End Sub

Function Version_equal_or_better(p_Vers)
	Dim l_VersNr
	l_VersNr=split(p_Vers,".")
	version_equal_or_better=(FF_GetMajor*1000+FF_GetMinor+FF_GetBuild/1000 >= l_VersNr(0)*1000+l_VersNr(1)+l_VersNr(2)/1000)
End Function

Sub Help
	if not KBvorhanden then	call KurzbeschreibungLesen
	if KBvorhanden then
		set WshShell =  CreateObject("WScript.Shell")
		WshShell.Popup Kurzbeschreibung,,"Info"
	else
		msgbox "Keine Kurzbeschreibung gefunden!",,"Meldung"
	end if
End Sub

'** Start Kurzbeschreibung *********************************
'Bannermaster
'====================================================
'
'Das Skript ordnet zwei oder mehr Bilder nebeneinander an und berblendet sie weich. Das ist z. B. gut geeignet, um Banner fr Webseiten zu erstellen.
' 
'Die Hhe des erzeugten Bildes richtet sich nach der geringsten Hhe der beteiligten Bilder.
' 
'Das Ma der berblendung wird mit dem Schieberegler eingestellt. Der Wert kann maximal die Breites des schmalsten Bildes erreichen.
' 
'<Reihenfolge umkehren> bringt die Bilder in die umgekehrte Reihenfolge
'
'Wenn die Parameter (Bildquelle, berlappung) verndert wurden, muss das Gesamtbild mit <Berechnen> neu erzeugt werden.
' 
'Auch beim Wechsel der Bildquelle findet eine Neuberechnung statt. Dies kann jeweils einen Augenblick dauern.
' 
'Die gewhlte Bilderquelle wird gespeichert und beim nchsten Start wieder aktiviert.
' 
'[Andreas Kleingnther  11/2011]
'** Ende Kurzbeschreibung **********************************

Sub KurzbeschreibungLesen
	on error resume next
	Const ForReading = 1
	Dim Skript, Anfang, Ende, Zeile
	
	Set objFS = CreateObject("Scripting.FileSystemObject")	 ' FileSystemObject
	Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)
	
	if err.number = 53 then
		msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   	"Die Kurzbeschreibung kann daher nicht angezeigt werden.",,"Meldung"
		exit sub
	end if
	
	Do While Skript.AtEndOfStream <> True
		Zeile = Skript.ReadLine
		
		if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
		if Ende then exit do
		
		if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
		if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
		
		if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	Loop
	if Anfang and Ende then KBvorhanden = true
	Skript.Close
	 On Error GoTo 0
End Sub